diff --git a/src/backend/commands/typecmds.c b/src/backend/commands/typecmds.c
index 4f5e7c7ccb..3719ea905e 100644
--- a/src/backend/commands/typecmds.c
+++ b/src/backend/commands/typecmds.c
@@ -345,7 +345,7 @@ DefineType(ParseState *pstate, List *names, List *parameters)
 		Form_pg_type likeForm;
 
 		likeType = typenameType(NULL, defGetTypeName(likeTypeEl), NULL);
-		likeForm = (Form_pg_type) GETSTRUCT(likeType);
+		likeForm = GETSTRUCT(pg_type, likeType);
 		internalLength = likeForm->typlen;
 		byValue = likeForm->typbyval;
 		alignment = likeForm->typalign;
@@ -668,7 +668,7 @@ RemoveTypeById(Oid typeOid)
 	 * making dependency entries for those, so it has to be done "by hand"
 	 * here.
 	 */
-	if (((Form_pg_type) GETSTRUCT(tup))->typtype == TYPTYPE_ENUM)
+	if ((GETSTRUCT(pg_type, tup))->typtype == TYPTYPE_ENUM)
 		EnumValuesDelete(typeOid);
 
 	/*
@@ -676,7 +676,7 @@ RemoveTypeById(Oid typeOid)
 	 * with making a dependency entry for that, so it has to be done "by hand"
 	 * here.
 	 */
-	if (((Form_pg_type) GETSTRUCT(tup))->typtype == TYPTYPE_RANGE)
+	if ((GETSTRUCT(pg_type, tup))->typtype == TYPTYPE_RANGE)
 		RangeDelete(typeOid);
 
 	ReleaseSysCache(tup);
@@ -758,7 +758,7 @@ DefineDomain(CreateDomainStmt *stmt)
 	 * Look up the base type.
 	 */
 	typeTup = typenameType(NULL, stmt->typeName, &basetypeMod);
-	baseType = (Form_pg_type) GETSTRUCT(typeTup);
+	baseType = GETSTRUCT(pg_type, typeTup);
 	basetypeoid = baseType->oid;
 
 	/*
@@ -1308,7 +1308,7 @@ AlterEnum(AlterEnumStmt *stmt)
 static void
 checkEnumOwner(HeapTuple tup)
 {
-	Form_pg_type typTup = (Form_pg_type) GETSTRUCT(tup);
+	Form_pg_type typTup = GETSTRUCT(pg_type, tup);
 
 	/* Check that this is actually an enum */
 	if (typTup->typtype != TYPTYPE_ENUM)
@@ -2587,7 +2587,7 @@ AlterDomainDefault(List *names, Node *defaultRaw)
 	tup = SearchSysCacheCopy1(TYPEOID, ObjectIdGetDatum(domainoid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", domainoid);
-	typTup = (Form_pg_type) GETSTRUCT(tup);
+	typTup = GETSTRUCT(pg_type, tup);
 
 	/* Check it's a domain and check user has permission for ALTER DOMAIN */
 	checkDomainOwner(tup);
@@ -2712,7 +2712,7 @@ AlterDomainNotNull(List *names, bool notNull)
 	tup = SearchSysCacheCopy1(TYPEOID, ObjectIdGetDatum(domainoid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", domainoid);
-	typTup = (Form_pg_type) GETSTRUCT(tup);
+	typTup = GETSTRUCT(pg_type, tup);
 
 	/* Check it's a domain and check user has permission for ALTER DOMAIN */
 	checkDomainOwner(tup);
@@ -2867,7 +2867,7 @@ AlterDomainDropConstraint(List *names, const char *constrName,
 		ObjectAddress conobj;
 
 		conobj.classId = ConstraintRelationId;
-		conobj.objectId = ((Form_pg_constraint) GETSTRUCT(contup))->oid;
+		conobj.objectId = (GETSTRUCT(pg_constraint, contup))->oid;
 		conobj.objectSubId = 0;
 
 		performDeletion(&conobj, behavior, 0);
@@ -2934,7 +2934,7 @@ AlterDomainAddConstraint(List *names, Node *newConstraint,
 	tup = SearchSysCacheCopy1(TYPEOID, ObjectIdGetDatum(domainoid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", domainoid);
-	typTup = (Form_pg_type) GETSTRUCT(tup);
+	typTup = GETSTRUCT(pg_type, tup);
 
 	/* Check it's a domain and check user has permission for ALTER DOMAIN */
 	checkDomainOwner(tup);
@@ -3088,7 +3088,7 @@ AlterDomainValidateConstraint(List *names, const char *constrName)
 				 errmsg("constraint \"%s\" of domain \"%s\" does not exist",
 						constrName, TypeNameToString(typename))));
 
-	con = (Form_pg_constraint) GETSTRUCT(tuple);
+	con = GETSTRUCT(pg_constraint, tuple);
 	if (con->contype != CONSTRAINT_CHECK)
 		ereport(ERROR,
 				(errcode(ERRCODE_WRONG_OBJECT_TYPE),
@@ -3109,7 +3109,7 @@ AlterDomainValidateConstraint(List *names, const char *constrName)
 	 * Now update the catalog, while we have the door open.
 	 */
 	copyTuple = heap_copytuple(tuple);
-	copy_con = (Form_pg_constraint) GETSTRUCT(copyTuple);
+	copy_con = GETSTRUCT(pg_constraint, copyTuple);
 	copy_con->convalidated = true;
 	CatalogTupleUpdate(conrel, &copyTuple->t_self, copyTuple);
 
@@ -3284,7 +3284,7 @@ get_rels_with_domain(Oid domainOid, LOCKMODE lockmode)
 
 	while (HeapTupleIsValid(depTup = systable_getnext(depScan)))
 	{
-		Form_pg_depend pg_depend = (Form_pg_depend) GETSTRUCT(depTup);
+		Form_pg_depend pg_depend = GETSTRUCT(pg_depend, depTup);
 		RelToCheck *rtc = NULL;
 		ListCell   *rellist;
 		Form_pg_attribute pg_att;
@@ -3421,7 +3421,7 @@ get_rels_with_domain(Oid domainOid, LOCKMODE lockmode)
 void
 checkDomainOwner(HeapTuple tup)
 {
-	Form_pg_type typTup = (Form_pg_type) GETSTRUCT(tup);
+	Form_pg_type typTup = GETSTRUCT(pg_type, tup);
 
 	/* Check that this is actually a domain */
 	if (typTup->typtype != TYPTYPE_DOMAIN)
@@ -3617,7 +3617,7 @@ RenameType(RenameStmt *stmt)
 	tup = SearchSysCacheCopy1(TYPEOID, ObjectIdGetDatum(typeOid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", typeOid);
-	typTup = (Form_pg_type) GETSTRUCT(tup);
+	typTup = GETSTRUCT(pg_type, tup);
 
 	/* check permissions on type */
 	if (!pg_type_ownercheck(typeOid, GetUserId()))
@@ -3702,7 +3702,7 @@ AlterTypeOwner(List *names, Oid newOwnerId, ObjectType objecttype)
 	newtup = heap_copytuple(tup);
 	ReleaseSysCache(tup);
 	tup = newtup;
-	typTup = (Form_pg_type) GETSTRUCT(tup);
+	typTup = GETSTRUCT(pg_type, tup);
 
 	/* Don't allow ALTER DOMAIN on a type */
 	if (objecttype == OBJECT_DOMAIN && typTup->typtype != TYPTYPE_DOMAIN)
@@ -3792,7 +3792,7 @@ AlterTypeOwner_oid(Oid typeOid, Oid newOwnerId, bool hasDependEntry)
 	tup = SearchSysCache1(TYPEOID, ObjectIdGetDatum(typeOid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", typeOid);
-	typTup = (Form_pg_type) GETSTRUCT(tup);
+	typTup = GETSTRUCT(pg_type, tup);
 
 	/*
 	 * If it's a composite type, invoke ATExecChangeOwner so that we fix up
@@ -3838,7 +3838,7 @@ AlterTypeOwnerInternal(Oid typeOid, Oid newOwnerId)
 	tup = SearchSysCacheCopy1(TYPEOID, ObjectIdGetDatum(typeOid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", typeOid);
-	typTup = (Form_pg_type) GETSTRUCT(tup);
+	typTup = GETSTRUCT(pg_type, tup);
 
 	memset(repl_null, false, sizeof(repl_null));
 	memset(repl_repl, false, sizeof(repl_repl));
@@ -3979,7 +3979,7 @@ AlterTypeNamespaceInternal(Oid typeOid, Oid nspOid,
 	tup = SearchSysCacheCopy1(TYPEOID, ObjectIdGetDatum(typeOid));
 	if (!HeapTupleIsValid(tup))
 		elog(ERROR, "cache lookup failed for type %u", typeOid);
-	typform = (Form_pg_type) GETSTRUCT(tup);
+	typform = GETSTRUCT(pg_type, tup);
 
 	oldNspOid = typform->typnamespace;
 	arrayOid = typform->typarray;
@@ -4113,7 +4113,7 @@ AlterType(AlterTypeStmt *stmt)
 	tup = typenameType(NULL, typename, NULL);
 
 	typeOid = typeTypeId(tup);
-	typForm = (Form_pg_type) GETSTRUCT(tup);
+	typForm = GETSTRUCT(pg_type, tup);
 
 	/* Process options */
 	memset(&atparams, 0, sizeof(atparams));
@@ -4427,7 +4427,7 @@ AlterTypeRecurse(Oid typeOid, bool isImplicitArray,
 	if (!isImplicitArray &&
 		(atparams->updateTypmodin || atparams->updateTypmodout))
 	{
-		Oid			arrtypoid = ((Form_pg_type) GETSTRUCT(newtup))->typarray;
+		Oid			arrtypoid = (GETSTRUCT(pg_type, newtup))->typarray;
 
 		if (OidIsValid(arrtypoid))
 		{
@@ -4476,7 +4476,7 @@ AlterTypeRecurse(Oid typeOid, bool isImplicitArray,
 
 	while ((domainTup = systable_getnext(scan)) != NULL)
 	{
-		Form_pg_type domainForm = (Form_pg_type) GETSTRUCT(domainTup);
+		Form_pg_type domainForm = GETSTRUCT(pg_type, domainTup);
 
 		/*
 		 * Shouldn't have a nonzero typbasetype in a non-domain, but let's
diff --git a/src/backend/commands/user.c b/src/backend/commands/user.c
index 984305ba31..767c75ce2f 100644
--- a/src/backend/commands/user.c
+++ b/src/backend/commands/user.c
@@ -446,7 +446,7 @@ CreateRole(ParseState *pstate, CreateRoleStmt *stmt)
 		{
 			RoleSpec   *oldrole = lfirst(item);
 			HeapTuple	oldroletup = get_rolespec_tuple(oldrole);
-			Form_pg_authid oldroleform = (Form_pg_authid) GETSTRUCT(oldroletup);
+			Form_pg_authid oldroleform = GETSTRUCT(pg_authid, oldroletup);
 			Oid			oldroleid = oldroleform->oid;
 			char	   *oldrolename = NameStr(oldroleform->rolname);
 
@@ -620,7 +620,7 @@ AlterRole(ParseState *pstate, AlterRoleStmt *stmt)
 	pg_authid_dsc = RelationGetDescr(pg_authid_rel);
 
 	tuple = get_rolespec_tuple(stmt->role);
-	authform = (Form_pg_authid) GETSTRUCT(tuple);
+	authform = GETSTRUCT(pg_authid, tuple);
 	rolename = pstrdup(NameStr(authform->rolname));
 	roleid = authform->oid;
 
@@ -838,7 +838,7 @@ AlterRoleSet(AlterRoleSetStmt *stmt)
 							"Cannot alter reserved roles.");
 
 		roletuple = get_rolespec_tuple(stmt->role);
-		roleform = (Form_pg_authid) GETSTRUCT(roletuple);
+		roleform = GETSTRUCT(pg_authid, roletuple);
 		roleid = roleform->oid;
 
 		/*
@@ -962,7 +962,7 @@ DropRole(DropRoleStmt *stmt)
 			continue;
 		}
 
-		roleform = (Form_pg_authid) GETSTRUCT(tuple);
+		roleform = GETSTRUCT(pg_authid, tuple);
 		roleid = roleform->oid;
 
 		if (roleid == GetUserId())
@@ -1117,7 +1117,7 @@ RenameRole(const char *oldname, const char *newname)
 	 * effective userid, though.
 	 */
 
-	authform = (Form_pg_authid) GETSTRUCT(oldtuple);
+	authform = GETSTRUCT(pg_authid, oldtuple);
 	roleid = authform->oid;
 
 	if (roleid == GetSessionUserId())
@@ -1165,7 +1165,7 @@ RenameRole(const char *oldname, const char *newname)
 	/*
 	 * createrole is enough privilege unless you want to mess with a superuser
 	 */
-	if (((Form_pg_authid) GETSTRUCT(oldtuple))->rolsuper)
+	if ((GETSTRUCT(pg_authid, oldtuple))->rolsuper)
 	{
 		if (!superuser())
 			ereport(ERROR,
@@ -1490,7 +1490,7 @@ AddRoleMems(const char *rolename, Oid roleid,
 										ObjectIdGetDatum(memberid));
 		if (HeapTupleIsValid(authmem_tuple) &&
 			(!admin_opt ||
-			 ((Form_pg_auth_members) GETSTRUCT(authmem_tuple))->admin_option))
+			 (GETSTRUCT(pg_auth_members, authmem_tuple))->admin_option))
 		{
 			ereport(NOTICE,
 					(errmsg("role \"%s\" is already a member of role \"%s\"",
diff --git a/src/backend/commands/vacuum.c b/src/backend/commands/vacuum.c
index 8df25f59d8..72a028f21f 100644
--- a/src/backend/commands/vacuum.c
+++ b/src/backend/commands/vacuum.c
@@ -806,7 +806,7 @@ expand_vacuum_rel(VacuumRelation *vrel, int options)
 		tuple = SearchSysCache1(RELOID, ObjectIdGetDatum(relid));
 		if (!HeapTupleIsValid(tuple))
 			elog(ERROR, "cache lookup failed for relation %u", relid);
-		classForm = (Form_pg_class) GETSTRUCT(tuple);
+		classForm = GETSTRUCT(pg_class, tuple);
 
 		/*
 		 * Make a returnable VacuumRelation for this rel if user is a proper
@@ -894,7 +894,7 @@ get_all_vacuum_rels(int options)
 
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		Form_pg_class classForm = (Form_pg_class) GETSTRUCT(tuple);
+		Form_pg_class classForm = GETSTRUCT(pg_class, tuple);
 		MemoryContext oldcontext;
 		Oid			relid = classForm->oid;
 
@@ -1346,7 +1346,7 @@ vac_update_relstats(Relation relation,
 	if (!HeapTupleIsValid(ctup))
 		elog(ERROR, "pg_class entry for relid %u vanished during vacuuming",
 			 relid);
-	pgcform = (Form_pg_class) GETSTRUCT(ctup);
+	pgcform = GETSTRUCT(pg_class, ctup);
 
 	/* Apply statistical updates, if any, to copied tuple */
 
@@ -1545,7 +1545,7 @@ vac_update_datfrozenxid(void)
 
 	while ((classTup = systable_getnext(scan)) != NULL)
 	{
-		Form_pg_class classForm = (Form_pg_class) GETSTRUCT(classTup);
+		Form_pg_class classForm = GETSTRUCT(pg_class, classTup);
 
 		/*
 		 * Only consider relations able to hold unfrozen XIDs (anything else
@@ -1639,7 +1639,7 @@ vac_update_datfrozenxid(void)
 	if (!HeapTupleIsValid(tuple))
 		elog(ERROR, "could not find tuple for database %u", MyDatabaseId);
 
-	dbform = (Form_pg_database) GETSTRUCT(tuple);
+	dbform = GETSTRUCT(pg_database, tuple);
 
 	/*
 	 * As in vac_update_relstats(), we ordinarily don't want to let
@@ -1747,7 +1747,7 @@ vac_truncate_clog(TransactionId frozenXID,
 
 	while ((tuple = heap_getnext(scan, ForwardScanDirection)) != NULL)
 	{
-		volatile FormData_pg_database *dbform = (Form_pg_database) GETSTRUCT(tuple);
+		volatile FormData_pg_database *dbform = GETSTRUCT(pg_database, tuple);
 		TransactionId datfrozenxid = dbform->datfrozenxid;
 		TransactionId datminmxid = dbform->datminmxid;
 
diff --git a/src/backend/commands/variable.c b/src/backend/commands/variable.c
index e5ddcda0b4..49f548d144 100644
--- a/src/backend/commands/variable.c
+++ b/src/backend/commands/variable.c
@@ -782,7 +782,7 @@ check_session_authorization(char **newval, void **extra, GucSource source)
 		return false;
 	}
 
-	roleform = (Form_pg_authid) GETSTRUCT(roleTup);
+	roleform = GETSTRUCT(pg_authid, roleTup);
 	roleid = roleform->oid;
 	is_superuser = roleform->rolsuper;
 
@@ -869,7 +869,7 @@ check_role(char **newval, void **extra, GucSource source)
 			return false;
 		}
 
-		roleform = (Form_pg_authid) GETSTRUCT(roleTup);
+		roleform = GETSTRUCT(pg_authid, roleTup);
 		roleid = roleform->oid;
 		is_superuser = roleform->rolsuper;
 
diff --git a/src/backend/executor/execAmi.c b/src/backend/executor/execAmi.c
index 44b2e0b82d..09c40fa1e1 100644
--- a/src/backend/executor/execAmi.c
+++ b/src/backend/executor/execAmi.c
@@ -612,7 +612,7 @@ IndexSupportsBackwardScan(Oid indexid)
 	ht_idxrel = SearchSysCache1(RELOID, ObjectIdGetDatum(indexid));
 	if (!HeapTupleIsValid(ht_idxrel))
 		elog(ERROR, "cache lookup failed for relation %u", indexid);
-	idxrelrec = (Form_pg_class) GETSTRUCT(ht_idxrel);
+	idxrelrec = GETSTRUCT(pg_class, ht_idxrel);
 
 	/* Fetch the index AM's API struct */
 	amroutine = GetIndexAmRoutineByAmId(idxrelrec->relam, false);
diff --git a/src/backend/executor/functions.c b/src/backend/executor/functions.c
index f9460ae506..4354928b11 100644
--- a/src/backend/executor/functions.c
+++ b/src/backend/executor/functions.c
@@ -178,7 +178,7 @@ prepare_sql_fn_parse_info(HeapTuple procedureTuple,
 						  Oid inputCollation)
 {
 	SQLFunctionParseInfoPtr pinfo;
-	Form_pg_proc procedureStruct = (Form_pg_proc) GETSTRUCT(procedureTuple);
+	Form_pg_proc procedureStruct = GETSTRUCT(pg_proc, procedureTuple);
 	int			nargs;
 
 	pinfo = (SQLFunctionParseInfoPtr) palloc0(sizeof(SQLFunctionParseInfo));
@@ -623,7 +623,7 @@ init_sql_fcache(FunctionCallInfo fcinfo, Oid collation, bool lazyEvalOK)
 	procedureTuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(foid));
 	if (!HeapTupleIsValid(procedureTuple))
 		elog(ERROR, "cache lookup failed for function %u", foid);
-	procedureStruct = (Form_pg_proc) GETSTRUCT(procedureTuple);
+	procedureStruct = GETSTRUCT(pg_proc, procedureTuple);
 
 	/*
 	 * copy function name immediately for use by error reporting callback, and
diff --git a/src/backend/executor/nodeAgg.c b/src/backend/executor/nodeAgg.c
index 2fc606cf29..668e3181ac 100644
--- a/src/backend/executor/nodeAgg.c
+++ b/src/backend/executor/nodeAgg.c
@@ -3666,7 +3666,7 @@ ExecInitAgg(Agg *node, EState *estate, int eflags)
 		if (!HeapTupleIsValid(aggTuple))
 			elog(ERROR, "cache lookup failed for aggregate %u",
 				 aggref->aggfnoid);
-		aggform = (Form_pg_aggregate) GETSTRUCT(aggTuple);
+		aggform = GETSTRUCT(pg_aggregate, aggTuple);
 
 		/* Check permission to call aggregate function */
 		aclresult = pg_proc_aclcheck(aggref->aggfnoid, GetUserId(),
@@ -3731,7 +3731,7 @@ ExecInitAgg(Agg *node, EState *estate, int eflags)
 			if (!HeapTupleIsValid(procTuple))
 				elog(ERROR, "cache lookup failed for function %u",
 					 aggref->aggfnoid);
-			aggOwner = ((Form_pg_proc) GETSTRUCT(procTuple))->proowner;
+			aggOwner = (GETSTRUCT(pg_proc, procTuple))->proowner;
 			ReleaseSysCache(procTuple);
 
 			if (OidIsValid(finalfn_oid))
diff --git a/src/backend/executor/nodeWindowAgg.c b/src/backend/executor/nodeWindowAgg.c
index 4b104c4d98..14b3547309 100644
--- a/src/backend/executor/nodeWindowAgg.c
+++ b/src/backend/executor/nodeWindowAgg.c
@@ -2775,7 +2775,7 @@ initialize_peragg(WindowAggState *winstate, WindowFunc *wfunc,
 	if (!HeapTupleIsValid(aggTuple))
 		elog(ERROR, "cache lookup failed for aggregate %u",
 			 wfunc->winfnoid);
-	aggform = (Form_pg_aggregate) GETSTRUCT(aggTuple);
+	aggform = GETSTRUCT(pg_aggregate, aggTuple);
 
 	/*
 	 * Figure out whether we want to use the moving-aggregate implementation,
@@ -2836,7 +2836,7 @@ initialize_peragg(WindowAggState *winstate, WindowFunc *wfunc,
 		if (!HeapTupleIsValid(procTuple))
 			elog(ERROR, "cache lookup failed for function %u",
 				 wfunc->winfnoid);
-		aggOwner = ((Form_pg_proc) GETSTRUCT(procTuple))->proowner;
+		aggOwner = (GETSTRUCT(pg_proc, procTuple))->proowner;
 		ReleaseSysCache(procTuple);
 
 		aclresult = pg_proc_aclcheck(transfn_oid, aggOwner,
diff --git a/src/backend/executor/spi.c b/src/backend/executor/spi.c
index 29bc26669b..72998c71fb 100644
--- a/src/backend/executor/spi.c
+++ b/src/backend/executor/spi.c
@@ -1291,7 +1291,7 @@ SPI_gettype(TupleDesc tupdesc, int fnumber)
 		return NULL;
 	}
 
-	result = pstrdup(NameStr(((Form_pg_type) GETSTRUCT(typeTuple))->typname));
+	result = pstrdup(NameStr((GETSTRUCT(pg_type, typeTuple))->typname));
 	ReleaseSysCache(typeTuple);
 	return result;
 }
diff --git a/src/backend/foreign/foreign.c b/src/backend/foreign/foreign.c
index cf222fc3e9..4f52075f03 100644
--- a/src/backend/foreign/foreign.c
+++ b/src/backend/foreign/foreign.c
@@ -62,7 +62,7 @@ GetForeignDataWrapperExtended(Oid fdwid, bits16 flags)
 		return NULL;
 	}
 
-	fdwform = (Form_pg_foreign_data_wrapper) GETSTRUCT(tp);
+	fdwform = GETSTRUCT(pg_foreign_data_wrapper, tp);
 
 	fdw = (ForeignDataWrapper *) palloc(sizeof(ForeignDataWrapper));
 	fdw->fdwid = fdwid;
@@ -136,7 +136,7 @@ GetForeignServerExtended(Oid serverid, bits16 flags)
 		return NULL;
 	}
 
-	serverform = (Form_pg_foreign_server) GETSTRUCT(tp);
+	serverform = GETSTRUCT(pg_foreign_server, tp);
 
 	server = (ForeignServer *) palloc(sizeof(ForeignServer));
 	server->serverid = serverid;
@@ -222,7 +222,7 @@ GetUserMapping(Oid userid, Oid serverid)
 						MappingUserName(userid))));
 
 	um = (UserMapping *) palloc(sizeof(UserMapping));
-	um->umid = ((Form_pg_user_mapping) GETSTRUCT(tp))->oid;
+	um->umid = (GETSTRUCT(pg_user_mapping, tp))->oid;
 	um->userid = userid;
 	um->serverid = serverid;
 
@@ -257,7 +257,7 @@ GetForeignTable(Oid relid)
 	tp = SearchSysCache1(FOREIGNTABLEREL, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for foreign table %u", relid);
-	tableform = (Form_pg_foreign_table) GETSTRUCT(tp);
+	tableform = GETSTRUCT(pg_foreign_table, tp);
 
 	ft = (ForeignTable *) palloc(sizeof(ForeignTable));
 	ft->relid = relid;
@@ -347,7 +347,7 @@ GetForeignServerIdByRelId(Oid relid)
 	tp = SearchSysCache1(FOREIGNTABLEREL, ObjectIdGetDatum(relid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for foreign table %u", relid);
-	tableform = (Form_pg_foreign_table) GETSTRUCT(tp);
+	tableform = GETSTRUCT(pg_foreign_table, tp);
 	serverid = tableform->ftserver;
 	ReleaseSysCache(tp);
 
@@ -372,7 +372,7 @@ GetFdwRoutineByServerId(Oid serverid)
 	tp = SearchSysCache1(FOREIGNSERVEROID, ObjectIdGetDatum(serverid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for foreign server %u", serverid);
-	serverform = (Form_pg_foreign_server) GETSTRUCT(tp);
+	serverform = GETSTRUCT(pg_foreign_server, tp);
 	fdwid = serverform->srvfdw;
 	ReleaseSysCache(tp);
 
@@ -380,7 +380,7 @@ GetFdwRoutineByServerId(Oid serverid)
 	tp = SearchSysCache1(FOREIGNDATAWRAPPEROID, ObjectIdGetDatum(fdwid));
 	if (!HeapTupleIsValid(tp))
 		elog(ERROR, "cache lookup failed for foreign-data wrapper %u", fdwid);
-	fdwform = (Form_pg_foreign_data_wrapper) GETSTRUCT(tp);
+	fdwform = GETSTRUCT(pg_foreign_data_wrapper, tp);
 	fdwhandler = fdwform->fdwhandler;
 
 	/* Complain if FDW has been set to NO HANDLER. */
diff --git a/src/backend/optimizer/plan/planagg.c b/src/backend/optimizer/plan/planagg.c
index 9330908cbf..c924c0e61c 100644
--- a/src/backend/optimizer/plan/planagg.c
+++ b/src/backend/optimizer/plan/planagg.c
@@ -505,7 +505,7 @@ fetch_agg_sort_op(Oid aggfnoid)
 	aggTuple = SearchSysCache1(AGGFNOID, ObjectIdGetDatum(aggfnoid));
 	if (!HeapTupleIsValid(aggTuple))
 		return InvalidOid;
-	aggform = (Form_pg_aggregate) GETSTRUCT(aggTuple);
+	aggform = GETSTRUCT(pg_aggregate, aggTuple);
 	aggsortop = aggform->aggsortop;
 	ReleaseSysCache(aggTuple);
 
diff --git a/src/backend/optimizer/plan/subselect.c b/src/backend/optimizer/plan/subselect.c
index df4ca12919..c80434b08c 100644
--- a/src/backend/optimizer/plan/subselect.c
+++ b/src/backend/optimizer/plan/subselect.c
@@ -866,7 +866,7 @@ hash_ok_operator(OpExpr *expr)
 		tup = SearchSysCache1(OPEROID, ObjectIdGetDatum(opid));
 		if (!HeapTupleIsValid(tup))
 			elog(ERROR, "cache lookup failed for operator %u", opid);
-		optup = (Form_pg_operator) GETSTRUCT(tup);
+		optup = GETSTRUCT(pg_operator, tup);
 		if (!optup->oprcanhash || !func_strict(optup->oprcode))
 		{
 			ReleaseSysCache(tup);
diff --git a/src/backend/optimizer/prep/prepagg.c b/src/backend/optimizer/prep/prepagg.c
index 404a5f1dac..45f28de829 100644
--- a/src/backend/optimizer/prep/prepagg.c
+++ b/src/backend/optimizer/prep/prepagg.c
@@ -152,7 +152,7 @@ preprocess_aggref(Aggref *aggref, PlannerInfo *root)
 	if (!HeapTupleIsValid(aggTuple))
 		elog(ERROR, "cache lookup failed for aggregate %u",
 			 aggref->aggfnoid);
-	aggform = (Form_pg_aggregate) GETSTRUCT(aggTuple);
+	aggform = GETSTRUCT(pg_aggregate, aggTuple);
 	aggtransfn = aggform->aggtransfn;
 	aggfinalfn = aggform->aggfinalfn;
 	aggcombinefn = aggform->aggcombinefn;
diff --git a/src/backend/optimizer/util/appendinfo.c b/src/backend/optimizer/util/appendinfo.c
index 9d4bb47027..a450c1e69f 100644
--- a/src/backend/optimizer/util/appendinfo.c
+++ b/src/backend/optimizer/util/appendinfo.c
@@ -150,7 +150,7 @@ make_inh_translation_list(Relation oldrelation, Relation newrelation,
 			if (!HeapTupleIsValid(newtup))
 				elog(ERROR, "could not find inherited attribute \"%s\" of relation \"%s\"",
 					 attname, RelationGetRelationName(newrelation));
-			new_attno = ((Form_pg_attribute) GETSTRUCT(newtup))->attnum - 1;
+			new_attno = (GETSTRUCT(pg_attribute, newtup))->attnum - 1;
 			Assert(new_attno >= 0 && new_attno < newnatts);
 			ReleaseSysCache(newtup);
 
diff --git a/src/backend/optimizer/util/clauses.c b/src/backend/optimizer/util/clauses.c
index 533df86ff7..277218abdc 100644
--- a/src/backend/optimizer/util/clauses.c
+++ b/src/backend/optimizer/util/clauses.c
@@ -3962,7 +3962,7 @@ simplify_function(Oid funcid, Oid result_type, int32 result_typmod,
 	func_tuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(func_tuple))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	func_form = (Form_pg_proc) GETSTRUCT(func_tuple);
+	func_form = GETSTRUCT(pg_proc, func_tuple);
 
 	/*
 	 * Process the function arguments, unless the caller did it already.
@@ -4056,7 +4056,7 @@ List *
 expand_function_arguments(List *args, bool include_out_arguments,
 						  Oid result_type, HeapTuple func_tuple)
 {
-	Form_pg_proc funcform = (Form_pg_proc) GETSTRUCT(func_tuple);
+	Form_pg_proc funcform = GETSTRUCT(pg_proc, func_tuple);
 	Oid		   *proargtypes = funcform->proargtypes.values;
 	int			pronargs = funcform->pronargs;
 	bool		has_named_args = false;
@@ -4136,7 +4136,7 @@ expand_function_arguments(List *args, bool include_out_arguments,
 static List *
 reorder_function_arguments(List *args, int pronargs, HeapTuple func_tuple)
 {
-	Form_pg_proc funcform = (Form_pg_proc) GETSTRUCT(func_tuple);
+	Form_pg_proc funcform = GETSTRUCT(pg_proc, func_tuple);
 	int			nargsprovided = list_length(args);
 	Node	   *argarray[FUNC_MAX_ARGS];
 	ListCell   *lc;
@@ -4267,7 +4267,7 @@ recheck_cast_function_args(List *args, Oid result_type,
 						   Oid *proargtypes, int pronargs,
 						   HeapTuple func_tuple)
 {
-	Form_pg_proc funcform = (Form_pg_proc) GETSTRUCT(func_tuple);
+	Form_pg_proc funcform = GETSTRUCT(pg_proc, func_tuple);
 	int			nargs;
 	Oid			actual_arg_types[FUNC_MAX_ARGS];
 	Oid			declared_arg_types[FUNC_MAX_ARGS];
@@ -4314,7 +4314,7 @@ evaluate_function(Oid funcid, Oid result_type, int32 result_typmod,
 				  HeapTuple func_tuple,
 				  eval_const_expressions_context *context)
 {
-	Form_pg_proc funcform = (Form_pg_proc) GETSTRUCT(func_tuple);
+	Form_pg_proc funcform = GETSTRUCT(pg_proc, func_tuple);
 	bool		has_nonconst_input = false;
 	bool		has_null_input = false;
 	ListCell   *arg;
@@ -4441,7 +4441,7 @@ inline_function(Oid funcid, Oid result_type, Oid result_collid,
 				HeapTuple func_tuple,
 				eval_const_expressions_context *context)
 {
-	Form_pg_proc funcform = (Form_pg_proc) GETSTRUCT(func_tuple);
+	Form_pg_proc funcform = GETSTRUCT(pg_proc, func_tuple);
 	char	   *src;
 	Datum		tmp;
 	bool		isNull;
@@ -5034,7 +5034,7 @@ inline_set_returning_function(PlannerInfo *root, RangeTblEntry *rte)
 	func_tuple = SearchSysCache1(PROCOID, ObjectIdGetDatum(func_oid));
 	if (!HeapTupleIsValid(func_tuple))
 		elog(ERROR, "cache lookup failed for function %u", func_oid);
-	funcform = (Form_pg_proc) GETSTRUCT(func_tuple);
+	funcform = GETSTRUCT(pg_proc, func_tuple);
 
 	/*
 	 * Forget it if the function is not SQL-language or has other showstopper
diff --git a/src/backend/optimizer/util/plancat.c b/src/backend/optimizer/util/plancat.c
index 5012bfe142..c163f1096e 100644
--- a/src/backend/optimizer/util/plancat.c
+++ b/src/backend/optimizer/util/plancat.c
@@ -1296,7 +1296,7 @@ get_relation_statistics_worker(List **stainfos, RelOptInfo *rel,
 	if (!HeapTupleIsValid(dtup))
 		return;
 
-	dataForm = (Form_pg_statistic_ext_data) GETSTRUCT(dtup);
+	dataForm = GETSTRUCT(pg_statistic_ext_data, dtup);
 
 	/* add one StatisticExtInfo for each kind built */
 	if (statext_is_kind_built(dtup, STATS_EXT_NDISTINCT))
@@ -1388,7 +1388,7 @@ get_relation_statistics(RelOptInfo *rel, Relation relation)
 		htup = SearchSysCache1(STATEXTOID, ObjectIdGetDatum(statOid));
 		if (!HeapTupleIsValid(htup))
 			elog(ERROR, "cache lookup failed for statistics object %u", statOid);
-		staForm = (Form_pg_statistic_ext) GETSTRUCT(htup);
+		staForm = GETSTRUCT(pg_statistic_ext, htup);
 
 		/*
 		 * First, build the array of columns covered.  This is ultimately
@@ -1994,7 +1994,7 @@ add_function_cost(PlannerInfo *root, Oid funcid, Node *node,
 	proctup = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(proctup))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	procform = (Form_pg_proc) GETSTRUCT(proctup);
+	procform = GETSTRUCT(pg_proc, proctup);
 
 	if (OidIsValid(procform->prosupport))
 	{
@@ -2055,7 +2055,7 @@ get_function_rows(PlannerInfo *root, Oid funcid, Node *node)
 	proctup = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcid));
 	if (!HeapTupleIsValid(proctup))
 		elog(ERROR, "cache lookup failed for function %u", funcid);
-	procform = (Form_pg_proc) GETSTRUCT(proctup);
+	procform = GETSTRUCT(pg_proc, proctup);
 
 	Assert(procform->proretset);	/* else caller error */
 
diff --git a/src/backend/parser/parse_clause.c b/src/backend/parser/parse_clause.c
index c655d188c7..36451e7d63 100644
--- a/src/backend/parser/parse_clause.c
+++ b/src/backend/parser/parse_clause.c
@@ -3617,7 +3617,7 @@ transformFrameOffset(ParseState *pstate, int frameOptions,
 		for (i = 0; i < proclist->n_members; i++)
 		{
 			HeapTuple	proctup = &proclist->members[i]->tuple;
-			Form_pg_amproc procform = (Form_pg_amproc) GETSTRUCT(proctup);
+			Form_pg_amproc procform = GETSTRUCT(pg_amproc, proctup);
 
 			/* The search will find all support proc types; ignore others */
 			if (procform->amprocnum != BTINRANGE_PROC)
diff --git a/src/backend/parser/parse_coerce.c b/src/backend/parser/parse_coerce.c
index c4e958e4aa..172d4b2034 100644
--- a/src/backend/parser/parse_coerce.c
+++ b/src/backend/parser/parse_coerce.c
@@ -853,7 +853,7 @@ build_coercion_expression(Node *node,
 		tp = SearchSysCache1(PROCOID, ObjectIdGetDatum(funcId));
 		if (!HeapTupleIsValid(tp))
 			elog(ERROR, "cache lookup failed for function %u", funcId);
-		procstruct = (Form_pg_proc) GETSTRUCT(tp);
+		procstruct = GETSTRUCT(pg_proc, tp);
 
 		/*
 		 * These Asserts essentially check that function is a legal coercion
@@ -3056,7 +3056,7 @@ IsBinaryCoercible(Oid srctype, Oid targettype)
 							ObjectIdGetDatum(targettype));
 	if (!HeapTupleIsValid(tuple))
 		return false;			/* no cast */
-	castForm = (Form_pg_cast) GETSTRUCT(tuple);
+	castForm = GETSTRUCT(pg_cast, tuple);
 
 	result = (castForm->castmethod == COERCION_METHOD_BINARY &&
 			  castForm->castcontext == COERCION_CODE_IMPLICIT);
@@ -3120,7 +3120,7 @@ find_coercion_pathway(Oid targetTypeId, Oid sourceTypeId,
 
 	if (HeapTupleIsValid(tuple))
 	{
-		Form_pg_cast castForm = (Form_pg_cast) GETSTRUCT(tuple);
+		Form_pg_cast castForm = GETSTRUCT(pg_cast, tuple);
 		CoercionContext castcontext;
 
 		/* convert char value for castcontext to CoercionContext enum */
@@ -3269,7 +3269,7 @@ find_typmod_coercion_function(Oid typeId,
 	result = COERCION_PATH_FUNC;
 
 	targetType = typeidType(typeId);
-	typeForm = (Form_pg_type) GETSTRUCT(targetType);
+	typeForm = GETSTRUCT(pg_type, targetType);
 
 	/* Check for a "true" array type */
 	if (IsTrueArrayType(typeForm))
@@ -3287,7 +3287,7 @@ find_typmod_coercion_function(Oid typeId,
 
 	if (HeapTupleIsValid(tuple))
 	{
-		Form_pg_cast castForm = (Form_pg_cast) GETSTRUCT(tuple);
+		Form_pg_cast castForm = GETSTRUCT(pg_cast, tuple);
 
 		*funcid = castForm->castfunc;
 		ReleaseSysCache(tuple);
@@ -3335,7 +3335,7 @@ typeIsOfTypedTable(Oid reltypeId, Oid reloftypeId)
 		if (!HeapTupleIsValid(tp))
 			elog(ERROR, "cache lookup failed for relation %u", relid);
 
-		reltup = (Form_pg_class) GETSTRUCT(tp);
+		reltup = GETSTRUCT(pg_class, tp);
 		if (reltup->reloftype == reloftypeId)
 			result = true;
 
diff --git a/src/backend/parser/parse_func.c b/src/backend/parser/parse_func.c
index f71a682cd6..c9be37c173 100644
--- a/src/backend/parser/parse_func.c
+++ b/src/backend/parser/parse_func.c
@@ -367,7 +367,7 @@ ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
 		tup = SearchSysCache1(AGGFNOID, ObjectIdGetDatum(funcid));
 		if (!HeapTupleIsValid(tup)) /* should not happen */
 			elog(ERROR, "cache lookup failed for aggregate %u", funcid);
-		classForm = (Form_pg_aggregate) GETSTRUCT(tup);
+		classForm = GETSTRUCT(pg_aggregate, tup);
 		aggkind = classForm->aggkind;
 		catDirectArgs = classForm->aggnumdirectargs;
 		ReleaseSysCache(tup);
@@ -1623,7 +1623,7 @@ func_get_detail(List *funcname,
 		if (!HeapTupleIsValid(ftup))	/* should not happen */
 			elog(ERROR, "cache lookup failed for function %u",
 				 best_candidate->oid);
-		pform = (Form_pg_proc) GETSTRUCT(ftup);
+		pform = GETSTRUCT(pg_proc, ftup);
 		*rettype = pform->prorettype;
 		*retset = pform->proretset;
 		*vatype = pform->provariadic;
@@ -1893,7 +1893,7 @@ FuncNameAsType(List *funcname)
 	if (typtup == NULL)
 		return InvalidOid;
 
-	if (((Form_pg_type) GETSTRUCT(typtup))->typisdefined &&
+	if ((GETSTRUCT(pg_type, typtup))->typisdefined &&
 		!OidIsValid(typeTypeRelid(typtup)))
 		result = typeTypeId(typtup);
 	else
